
local timeTot = 0
local LotteryCashNr = 0
local myVendingAmount = 0
local LotteryTicketsNr = 0

local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

function FindMySafe()
	MySafe = nil
	local nearbySafes = Find(this,"LotterySafe",10000)
	if next(nearbySafes) then
		for thatSafe, dist in pairs(nearbySafes) do
			MySafe = thatSafe
			if not thatSafe.WeeklyLottery then
				this.SubType = 0
			else
				this.SubType = 1
			end
			break
		end
	end
end

function FindStackNumbers()
	local newStack = Object.Spawn("Stack", this.Pos.x, this.Pos.y)
	for i = 1,2000 do
		Set(newStack,"Quantity",2)
		Set(newStack,"Contents",i)
		if newStack.Contents == "LotteryCash" then
			LotteryCashNr = i
		end
		if newStack.Contents == "VendingLotteryTicket" then
			LotteryTicketsNr = i
		end
		if LotteryCashNr > 1 and LotteryTicketsNr > 1 then
			newStack.Delete()
			break
		end
	end
end

function getObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end

function getEntity(id,dist)
	--print("trying to find entity")
	local entityGroup = { "Prisoner", "Guard", "Workman", "Cook", "Gardener", "Janitor", "DogHandler",
						"Doctor", "ArmedGuard", "Sniper", "PlantationWorker", "GardenWorker",
						"GreenhouseWorker", "ForestryWorker", "Barber", "GraveDigger", 
						"CarMechanic2", "CraneOperator2", "SmartPhoneGenius", "Tailor", "YogaMaster",
						"PrisonFiremanA0", "PrisonFiremanA1", "PrisonFiremanA2", "PrisonFiremanA3",
						"PrisonFiremanB0", "PrisonFiremanB1", "PrisonFiremanB2", "PrisonFiremanB3",
						"PrisonFiremanC0", "PrisonFiremanC1", "PrisonFiremanC2", "PrisonFiremanC3",
						"PrisonFiremanD0", "PrisonFiremanD1", "PrisonFiremanD2", "PrisonFiremanD3",
						"SystemAdministrator","SimulationOfficeManager","ComputerNerd",
						"Accountant", "Lawyer", "Foreman", "Chief", "Psychologist" }
	for _, typ in pairs(entityGroup) do
		local entityType = Object.GetNearbyObjects(typ,dist or 1)
		for thatEntity, _ in pairs(entityType) do
			if thatEntity.Id.i==id then
				return thatEntity
			end
		end
		entityType=nil
	end
	entityGroup=nil
end

function Create()
	this.Pos.y = this.Pos.y-0.5
	this.inUse = false
	mySign = Object.Spawn("OutOfOrderSign",this.Pos.x,this.Pos.y)
	mySign.CarrierId.i = this.Id.i
	mySign.CarrierId.u = this.Id.u
	mySign.Loaded = true
	this.Slot1.i = mySign.Id.i
	this.Slot1.u = mySign.Id.u
	Set(mySign,"IsLotterySign",true)
	this.SignPlaced = true
	this.V1 = true
end

function Update(timePassed)
	if timePerUpdate == nil then
		if not this.V1 then
			if this.SignPlaced == true then
				mySign = getObject("OutOfOrderSign",this.Slot0.i)
				if mySign ~= nil then mySign.Delete() end
			else
				myVendingStack = getObject("VendingLotteryTicketLoaded",this.Slot1.i)
				if myVendingStack ~= nil then myVendingStack.Delete() end
			end
			this.Delete()
			return
		end
		FindMySafe()
		FindStackNumbers()
		timePerUpdate = 0
	end
	timeTot=timeTot+timePassed
	if timeTot > timePerUpdate then
		timeTot=0
		if tonumber(this.Slot0.i) == -1 then
			if this.SignPlaced == false and tonumber(this.Slot1.i) == -1 then
				mySign = Object.Spawn("OutOfOrderSign",this.Pos.x,this.Pos.y)
				mySign.CarrierId.i = this.Id.i
				mySign.CarrierId.u = this.Id.u
				mySign.Loaded = true
				this.Slot1.i = mySign.Id.i
				this.Slot1.u = mySign.Id.u
				this.SignPlaced = true
				Set(mySign,"IsLotterySign",true)
				
				myVendingStack = nil
				myVendingAmount = 0
				
				this.Tooltip = "tooltip_LotteryTicketVendingMachine0Items"
			end
			Object.CreateJob(this,"FillLotteryVendingMachine")
		else
			if this.SignPlaced == true then
				if mySign ~= nil then
					mySign.Delete()
				else
					mySign = getObject("OutOfOrderSign",this.Slot1.i)
					if mySign ~= nil then
						mySign.Delete()
					end
				end
				this.SignPlaced = false
				Object.CancelJob(this,"FillLotteryVendingMachine")
			end
		end

		if tonumber(this.Slot0.i) > -1 and myVendingAmount == 0 then
			myVendingStack = getObject("Stack",this.Slot0.i)
			if myVendingStack ~= nil then
				myVendingAmount = myVendingStack.Quantity
			else
				myVendingAmount = 0
			end
		end

		if this.SignPlaced==false and tonumber(this.Slot1.i) > -1 then
			if not this.inUse then
				this.inUse = true
				theEntity = getEntity(this.Slot1.i)
				if theEntity ~= nil and myVendingStack ~= nil and myVendingStack.Quantity ~= nil then
					this.Sound("VendingMachine","CoinDrop")
					myTicket = Object.Spawn("VendingLotteryTicket",myVendingStack.Pos.x,myVendingStack.Pos.y+0.25)
					myTicket.SubType = this.SubType
					Object.SetProperty(myTicket,"FindEntity",theEntity.Id.i)
					myVendingStack.Quantity = myVendingStack.Quantity - 1
					myVendingAmount = myVendingStack.Quantity
					this.Tooltip = { "tooltip_LotteryTicketVendingMachineXItems",myVendingAmount,"X" }
					
					if myVendingAmount <= 1 then
						myVendingStack.CarrierId.i = -1
						myVendingStack.CarrierId.u = -1
						myVendingStack.Loaded = false
						this.Slot0.i = -1
						this.Slot0.u = -1
						myVendingStack.Delete()
						myVendingStack = nil
						myVendingAmount = 0
						this.Tooltip = { "tooltip_LotteryTicketVendingMachineXItems",myVendingAmount,"X" }
						myEarnings = Object.Spawn("VendingEarnings",this.Pos.x-0.25,this.Pos.y+0.25)
					end
					
					if theEntity.Type == "Prisoner" and theEntity.AvailableMoney >= 2 then
						theStake = math.random(1,theEntity.AvailableMoney)
						theEntity.AvailableMoney = theEntity.AvailableMoney - theStake
						if Get(theEntity,"TicketsBought") == nil then
							Set(theEntity,"TicketsBought",1)
							Set(theEntity,"T1",math.floor(World.TimeIndex))
						else
							Set(theEntity,"TicketsBought",Get(theEntity,"TicketsBought")+1)
							Set(theEntity,"T"..theEntity.TicketsBought,math.floor(World.TimeIndex))
						end
						if Get(theEntity,"Stake") == nil then
							Set(theEntity,"Stake",theStake)
						else
							Set(theEntity,"Stake",Get(theEntity,"Stake")+theStake)
						end
					elseif theEntity.Type ~= "Prisoner" then
						if Get(theEntity,"TicketsBought") == nil then
							Set(theEntity,"TicketsBought",1)
							Set(theEntity,"T1",math.floor(World.TimeIndex))
						else
							Set(theEntity,"TicketsBought",Get(theEntity,"TicketsBought")+1)
							Set(theEntity,"T"..theEntity.TicketsBought,math.floor(World.TimeIndex))
						end
						theStake = math.random(100,200)
					end
					if MySafe == nil or MySafe.SubType == nil then FindMySafe() end
					if MySafe ~= nil and MySafe.TotalStake ~= nil then
						Set(MySafe,"TicketsSold",MySafe.TicketsSold + 1)
						Set(MySafe,"LastStake",theStake)
						if this.Slot2.i == -1 then
							myStake = Object.Spawn("Stack",this.Pos.x,this.Pos.y)
							myStake.Contents = LotteryCashNr
							myStake.Quantity = theStake
							this.Slot2.i = myStake.Id.i
							this.Slot2.u = myStake.Id.u
							myStake.CarrierId.i = this.Id.i
							myStake.CarrierId.u = this.Id.u
							myStake.Loaded = true
						else
							myStake = getObject("Stack",this.Slot2.i,1)
							if myStake ~= nil and myStake.SubType ~= nil then
								myStake.Quantity = myStake.Quantity + theStake
							else
								myStake = Object.Spawn("Stack",this.Pos.x,this.Pos.y)
								myStake.Contents = LotteryCashNr
								myStake.Quantity = theStake
								this.Slot2.i = myStake.Id.i
								this.Slot2.u = myStake.Id.u
								myStake.CarrierId.i = this.Id.i
								myStake.CarrierId.u = this.Id.u
								myStake.Loaded = true
							end
						end
					end
					theStake = nil
				end
			end
		else
			if myVendingStack ~= nil and myVendingStack.Quantity ~= nil then
				myVendingAmount = myVendingStack.Quantity
			else
				myVendingAmount = 0
			end
			this.Tooltip = { "tooltip_LotteryTicketVendingMachineXItems",myVendingAmount,"X" }
			this.inUse = false
		end
	end
end

function JobComplete_FillLotteryVendingMachine()
	if LotteryTicketsNr == 0 then FindStackNumbers() end
	myVendingStack = Object.Spawn("Stack",this.Pos.x,this.Pos.y)
	myVendingStack.Contents = LotteryTicketsNr
	myVendingStack.Quantity = 100
	myVendingAmount = 100
	this.Slot0.i = myVendingStack.Id.i
	this.Slot0.u = myVendingStack.Id.u
	myVendingStack.CarrierId.i = this.Id.i
	myVendingStack.CarrierId.u = this.Id.u
	myVendingStack.Loaded = true
	Object.CancelJob(this,"FillLotteryVendingMachine")
end
