
local timeTot=0
local timePerUpdate=1

local Get = Object.GetProperty
local Set = Object.SetProperty

function getEntity(id,dist)
	local entityGroup = { "Prisoner", "Guard", "Workman", "Cook", "Gardener", "Janitor", "DogHandler",
						"Doctor", "ArmedGuard", "Sniper", "PlantationWorker", "GardenWorker",
						"GreenhouseWorker", "ForestryWorker", "Barber", "GraveDigger", 
						"CarMechanic2", "CraneOperator2", "SmartPhoneGenius", "Tailor", "YogaMaster",
						"PrisonFiremanA0", "PrisonFiremanA1", "PrisonFiremanA2", "PrisonFiremanA3",
						"PrisonFiremanB0", "PrisonFiremanB1", "PrisonFiremanB2", "PrisonFiremanB3",
						"PrisonFiremanC0", "PrisonFiremanC1", "PrisonFiremanC2", "PrisonFiremanC3",
						"PrisonFiremanD0", "PrisonFiremanD1", "PrisonFiremanD2", "PrisonFiremanD3",
						"SystemAdministrator","SimulationOfficeManager","ComputerNerd",
						"Accountant", "Lawyer", "Foreman", "Chief", "Psychologist" }
	for _, typ in pairs(entityGroup) do
		local entityType = Object.GetNearbyObjects(typ,dist or 1)
		for thatEntity, _ in pairs(entityType) do
			if thatEntity.Id.i==id then
				return thatEntity
			end
		end
		entityType=nil
	end
	entityGroup=nil
end

function Create()
end

function Update(timePassed)
	timeTot=timeTot+timePassed
	if timeTot>timePerUpdate then
		timeTot=0
		timePerUpdate=0
		if theEntity == nil then
			theEntity = getEntity(this.FindEntity,2)
			if theEntity~=nil then
				if theEntity.Type == "Prisoner" then
					if this.SubType ~= 3 then
						local correctItem = "VendingLotteryTicketSpawned"..this.SubType
						for i = 57,100 do
							theEntity.Equipment = this.SubType+i
							if theEntity.Equipment == correctItem then
								break
							end
						end
						Set(theEntity,"VendingTimer",120)
						this.Pos.x,this.Pos.y = theEntity.Pos.x,theEntity.Pos.y
						this.SubType = 3
					else		-- delete after loadgame
						theEntity.Equipment = 0
						Set(theEntity,"VendingTimer",nil)
						this.Delete()
					end
				else
					Set(theEntity,"Carrying.i",this.Id.i)
					Set(theEntity,"Carrying.u",this.Id.u)
					Set(this,"CarrierId.i",theEntity.Id.i)
					Set(this,"CarrierId.u",theEntity.Id.u)
					Set(this,"Carried",4)
					Object.NavigateTo(theEntity,this.Pos.x,this.Pos.y)
				end
			else
				this.Delete()
			end
		else
			if theEntity.Type == "Prisoner" then
				this.Pos.x,this.Pos.y = theEntity.Pos.x,theEntity.Pos.y
				if Get(theEntity,"VendingTimer") ~= nil then
					Set(theEntity,"VendingTimer",Get(theEntity,"VendingTimer") - 1)
					if theEntity.VendingTimer <= 0 then
						theEntity.Equipment = 0
						Set(theEntity,"VendingTimer",nil)
						this.Delete()
					end
				else
					theEntity.Equipment = 0
					this.Delete()
				end
			else
				--print(this.Carried)
				if this.Carried~=4 then
					this.Delete()
				end
			end
		end
	end
end
